package applicationLogic;

/**
 * The Class Article.
 */
public class Article extends ShortPrinting {
	
	/** The author. */
	private String author;
	
	/** The magazine. */
	private Magazine magazine;
	
	/** The page. */
	private int page;
	
	/**
	 * Instantiates a new article.
	 *
	 * @param title the title
	 * @param year the year
	 * @param edition the edition
	 * @param author the author
	 * @param magazine the magazine
	 * @param page the page
	 */
	public Article(String title, int year, int edition, String author, Magazine magazine, int page)
	{
		super(title, year, edition);
		this.author = author;
		this.magazine = magazine;
		this.page = page;
	}
	
	/**
	 * Gets the magazine.
	 *
	 * @return the magazine
	 */
	public Magazine getMagazine() {
		return magazine;
	}

	/**
	 * Sets the magazine.
	 *
	 * @param magazine the new magazine
	 */
	public void setMagazine(Magazine magazine) {
		this.magazine = magazine;
	}

	/**
	 * Gets the page.
	 *
	 * @return the page
	 */
	public int getPage() {
		return page;
	}

	/**
	 * Sets the page.
	 *
	 * @param page the new page
	 */
	public void setPage(int page) {
		this.page = page;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(String author) {
		this.author = author;
	}

	/* (non-Javadoc)
	 * @see applicationLogic.ShortPrinting#toString()
	 */
	public String toString()
	{
		return super.toString() + ", Magazine: " + magazine.getTitle() + ", page: " + page;
	}
}
