package applicationLogic;

import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;

/**
 * The Class Book.
 */
public class Book extends Printing {
	
	/** The author. */
	private String author;
	
	/** The date of publication. */
	private GregorianCalendar dateOfPublication;
	
	/** The publisher. */
	private String publisher;
	
	/** The isbn. */
	private String isbn;
	
	/**
	 * Instantiates a new book.
	 *
	 * @param title the title
	 * @param author the author
	 * @param dateOfPublication the date of publication
	 * @param publisher the publisher
	 * @param isbn the isbn
	 */
	public Book(String title, String author, GregorianCalendar dateOfPublication, String publisher, String isbn) {
		super(title);
		this.author = author;
		this.dateOfPublication = dateOfPublication;
		this.publisher = publisher;
		this.isbn = isbn;
	}


	/**
	 * Gets the date of publication.
	 *
	 * @return the date of publication
	 */
	public GregorianCalendar getDateOfPublication() {
		return dateOfPublication;
	}


	/**
	 * Sets the date of publication.
	 *
	 * @param dateOfPublication the new date of publication
	 */
	public void setDateOfPublication(GregorianCalendar dateOfPublication) {
		this.dateOfPublication = dateOfPublication;
	}


	/**
	 * Gets the publisher.
	 *
	 * @return the publisher
	 */
	public String getPublisher() {
		return publisher;
	}


	/**
	 * Sets the publisher.
	 *
	 * @param publisher the new publisher
	 */
	public void setPublisher(String publisher) {
		this.publisher = publisher;
	}


	/**
	 * Gets the isbn.
	 *
	 * @return the isbn
	 */
	public String getIsbn() {
		return isbn;
	}


	/**
	 * Sets the isbn.
	 *
	 * @param isbn the new isbn
	 */
	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}
	
	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}
	
	/**
	 * Sets the author.
	 *
	 * @param author the new author
	 */
	public void setAuthor(String author) {
		this.author = author;
	}


	/* (non-Javadoc)
	 * @see applicationLogic.Printing#toString()
	 */
	public String toString()
	{
		SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy");
		String dateStr = sdf.format(dateOfPublication.getTime());
		return super.toString() + ", Publisher: " + this.publisher + ", Date of Publication: " + dateStr + ", ISBN: " + this.isbn;
	}
}
