package applicationLogic;

import java.io.Serializable;

/**
 * The Class Printing.
 */
public abstract class Printing implements Serializable, Comparable<Printing> {
	
	/** The global id. */
	private static int globalID = 0;
	
	/** The id. */
	private int id;
	
	/** The title. */
	private String title;
	
	
	
	/**
	 * Instantiates a new printing.
	 *
	 * @param title the title
	 */
	public Printing(String title)
	{
		id = Printing.globalID;
		Printing.globalID++;
		this.title = title;
	}
	
	/**
	 * Gets the global id.
	 *
	 * @return the global id
	 */
	public static int getGlobalID() {
		return globalID;
	}
	
	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	public int getId() {
		return id;
	}
	
	/**
	 * Sets the id.
	 *
	 * @param id the new id
	 */
	public void setId(int id) {
		this.id = id;
	}
	
	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}
	
	/**
	 * Sets the title.
	 *
	 * @param title the new title
	 */
	public void setTitle(String title) {
		this.title = title;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return "ID: " + id + ", Type: " + this.getClass().getSimpleName() +", title: " + title;
	}
	@Override
	public int compareTo(Printing a1)	
	{
	    if (a1.getTitle() == null && this.getTitle() == null) {
	        return 0;
	      }
	      if (this.getTitle() == null) {
	        return 1;
	      }
	      if (a1.getTitle() == null) {
	        return -1;
	      }
	      return this.getTitle().compareToIgnoreCase(a1.getTitle());
	}
	
}
