package applicationLogic;

/**
 * The Class ShortPrinting.
 */
public abstract class ShortPrinting extends Printing {
	
	/** The year. */
	private int year;
	
	/** The edition. */
	private int edition;
	
	/**
	 * Instantiates a new short printing.
	 *
	 * @param title the title
	 * @param year the year
	 * @param edition the edition
	 */
	public ShortPrinting(String title, int year, int edition) {
		super(title);
		this.year = year;
		this.edition = edition;
	}
	
	/**
	 * Gets the year.
	 *
	 * @return the year
	 */
	public int getYear() {
		return year;
	}

	/**
	 * Sets the year.
	 *
	 * @param year the new year
	 */
	public void setYear(int year) {
		this.year = year;
	}
	
	/**
	 * Gets the edition.
	 *
	 * @return the edition
	 */
	public int getEdition() {
		return edition;
	}
	
	/**
	 * Sets the edition.
	 *
	 * @param edition the new edition
	 */
	public void setEdition(int edition) {
		this.edition = edition;
	}

	/* (non-Javadoc)
	 * @see applicationLogic.Printing#toString()
	 */
	public String toString()
	{
		return super.toString() + ", stuff number: " + year;
	}
}
