package userInterface;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.Iterator;

import applicationLogic.BadPrintingException;
import applicationLogic.InvalidInputException;
import applicationLogic.InvalidMagazineID;
import applicationLogic.Printing;
import applicationLogicAccess.Access;

/**
 * The Class Test.
 */
public class Test {

	/**
	 * Prints the array list.
	 *
	 * @param list the list
	 * @param description the description
	 */
	public static void printArrayList(ArrayList<Printing> list, String description)
	{
		System.out.println("\n----------------");
		System.out.println("List of: " + description);
		Iterator<Printing> it = list.iterator();
		while (it.hasNext())
		{
			Printing actual = it.next();
			System.out.println(actual); //calls toString Method from Element
		}
		System.out.println("\\END List-------\n");
	}
	
	
	/**
	 * The main method.
	 *
	 * @param args the arguments
	 * @throws BadPrintingException 
	 * @throws InvalidInputException 
	 * @throws InvalidMagazineID 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws BadPrintingException, InvalidInputException, InvalidMagazineID, IOException 
	{
		boolean file_or_xml = true;
		System.out.println("STARTING TEST-APPLICATION\n\n");
		System.out.println("First try to deserialize:");
		try {
			Access.load(file_or_xml);
			System.out.println("Success! \n");
		} catch (FileNotFoundException e) {
			System.out.println("Fehler beim laden.");
		} catch (ClassNotFoundException e) {
			System.out.println("Fehler beim Laden.");
		} catch (IOException e){
			System.out.println("Fehler beim Laden.");
		}
		int id;
		id = Access.insertBook("Java ist auch eine Insel", "Christian Ullenboom", new GregorianCalendar(2005, 10, 1), "Galileo Openbooks", "978-3-8362-1371-4");
		System.out.println(id + " added");
		id = Access.insertMagazine("ct", 2010, 5, "heise Verlag");
		System.out.println(id + " added");
		id = Access.insertMagazine("iX", 2010, 1, "heise Verlag");
		System.out.println(id + " added");
		id = Access.insertMagazine("chip", 2010, 2, "chip");
		System.out.println(id + " added");
		id = Access.insertArticle("ct", 2010, 3, "Max Mustermann", 1, 1);
		System.out.println(id + " added");
		id = Access.insertArticle("Digitale Signaturen", 2009, 3, "Theo", 3, 104);
		System.out.println(id + " added");
		id = Access.insertArticle("GPUs", 2005, 13, "Alleswisser", 1, 22);
		System.out.println(id + " added");
		
		
		
		printArrayList(Access.getAllPrintings(), "all printings");
		int delId = 5;
		try {
			Access.deletePrinting(delId);
		} catch (BadPrintingException e){
			System.out.println("Fehler beim löschen!");
		}
		/* old delete method...
		if (Access.deletePrinting(delId)) System.out.println(delId + " deleted");
			else System.out.println("could'nt delete " + delId);
		*/
		printArrayList(Access.getAllPrintings(), "all printings after deleting " + delId);
		
		printArrayList(Access.filterPrintings("Magazine"), "filter magazines");
		
		printArrayList(Access.getPrintingsByName("ct"), "get printings with name=\"ct\"");

		printArrayList(Access.sortTitle(), "sort printings to title:");
		
		printArrayList(Access.sortType(), "sort printings to type:");
		
		printArrayList(Access.sortTitle_was(), "sort printings with Array Sort");
		
		printArrayList(Access.sortID(), "sort printings with ID's");

		
		try {
			Access.safe(file_or_xml);
			System.out.println("Serialized! Nodda =)");
		} catch (FileNotFoundException e){
			System.out.println("Fehler beim Speichern!");
		} catch (IOException e){
			System.out.println("Fehler beim Speichern!");
		}
	}
	

}
